class F {
  constructor(e, s, i, a) {
    i || (i = (s || []).map((l) => (l || "").slice(0, 3))), this.language = e, this.months = s, this.monthsAbbr = i, this.days = a, this.rtl = !1, this.ymd = !1, this.yearSuffix = "";
  }
  get language() {
    return this._language;
  }
  set language(e) {
    if (typeof e != "string")
      throw new TypeError("Language must be a string");
    this._language = e;
  }
  get months() {
    return this._months;
  }
  set months(e) {
    if (e.length !== 12)
      throw new RangeError(
        `There must be 12 months for ${this.language} language`
      );
    this._months = e;
  }
  get monthsAbbr() {
    return this._monthsAbbr;
  }
  set monthsAbbr(e) {
    if (e.length !== 12)
      throw new RangeError(
        `There must be 12 abbreviated months for ${this.language} language`
      );
    this._monthsAbbr = e;
  }
  get days() {
    return this._days;
  }
  set days(e) {
    if (e.length !== 7)
      throw new RangeError(`There must be 7 days for ${this.language} language`);
    this._days = e;
  }
}
const v = new F(
  "English",
  [
    "January",
    "February",
    "March",
    "April",
    "May",
    "June",
    "July",
    "August",
    "September",
    "October",
    "November",
    "December"
  ],
  [
    "Jan",
    "Feb",
    "Mar",
    "Apr",
    "May",
    "Jun",
    "Jul",
    "Aug",
    "Sep",
    "Oct",
    "Nov",
    "Dec"
  ],
  ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"]
), C = {
  /**
   * @type {Boolean}
   */
  useUtc: !1,
  /**
   * Returns the full year, using UTC or not
   * @param {Date} date
   */
  getFullYear(t) {
    return this.useUtc ? t.getUTCFullYear() : t.getFullYear();
  },
  /**
   * Returns the month, using UTC or not
   * @param {Date} date
   */
  getMonth(t) {
    return this.useUtc ? t.getUTCMonth() : t.getMonth();
  },
  /**
   * Returns the date, using UTC or not
   * @param {Date} date
   */
  getDate(t) {
    return this.useUtc ? t.getUTCDate() : t.getDate();
  },
  /**
   * Returns the day, using UTC or not
   * @param {Date} date
   */
  getDay(t) {
    return this.useUtc ? t.getUTCDay() : t.getDay();
  },
  /**
   * Returns the hours, using UTC or not
   * @param {Date} date
   */
  getHours(t) {
    return this.useUtc ? t.getUTCHours() : t.getHours();
  },
  /**
   * Returns the minutes, using UTC or not
   * @param {Date} date
   */
  getMinutes(t) {
    return this.useUtc ? t.getUTCMinutes() : t.getMinutes();
  },
  /**
   * Sets the full year, using UTC or not
   * @param {Date} date
   */
  setFullYear(t, e) {
    return this.useUtc ? t.setUTCFullYear(e) : t.setFullYear(e);
  },
  /**
   * Sets the month, using UTC or not
   * @param {Date} date
   */
  setMonth(t, e) {
    return this.useUtc ? t.setUTCMonth(e) : t.setMonth(e);
  },
  /**
   * Sets the date, using UTC or not
   * @param {Date} date
   * @param {Number} value
   */
  setDate(t, e) {
    return this.useUtc ? t.setUTCDate(e) : t.setDate(e);
  },
  /**
   * Check if date1 is equivalent to date2, without comparing the time
   * @see https://stackoverflow.com/a/6202196/4455925
   * @param {Date} date1
   * @param {Date} date2
   */
  compareDates(t, e) {
    const s = new Date(t.getTime()), i = new Date(e.getTime());
    return this.useUtc ? (s.setUTCHours(0, 0, 0, 0), i.setUTCHours(0, 0, 0, 0)) : (s.setHours(0, 0, 0, 0), i.setHours(0, 0, 0, 0)), s.getTime() === i.getTime();
  },
  /**
   * Validates a date object
   * @param {Date} date - an object instantiated with the new Date constructor
   * @return {Boolean}
   */
  isValidDate(t) {
    return Object.prototype.toString.call(t) !== "[object Date]" ? !1 : !isNaN(t.getTime());
  },
  /**
   * Return abbreviated week day name
   * @param {Date}
   * @param {Array}
   * @return {String}
   */
  getDayNameAbbr(t, e) {
    if (typeof t != "object")
      throw TypeError("Invalid Type");
    return e[this.getDay(t)];
  },
  /**
   * Return name of the month
   * @param {Number|Date}
   * @param {Array}
   * @return {String}
   */
  getMonthName(t, e) {
    if (!e)
      throw Error("missing 2nd parameter Months array");
    if (typeof t == "object")
      return e[this.getMonth(t)];
    if (typeof t == "number")
      return e[t];
    throw TypeError("Invalid type");
  },
  /**
   * Return an abbreviated version of the month
   * @param {Number|Date}
   * @return {String}
   */
  getMonthNameAbbr(t, e) {
    if (!e)
      throw Error("missing 2nd paramter Months array");
    if (typeof t == "object")
      return e[this.getMonth(t)];
    if (typeof t == "number")
      return e[t];
    throw TypeError("Invalid type");
  },
  /**
   * Alternative get total number of days in month
   * @param {Number} year
   * @param {Number} m
   * @return {Number}
   */
  daysInMonth(t, e) {
    return /8|3|5|10/.test(e) ? 30 : e === 1 ? !(t % 4) && t % 100 || !(t % 400) ? 29 : 28 : 31;
  },
  /**
   * Get nth suffix for date
   * @param {Number} day
   * @return {String}
   */
  getNthSuffix(t) {
    switch (t) {
      case 1:
      case 21:
      case 31:
        return "st";
      case 2:
      case 22:
        return "nd";
      case 3:
      case 23:
        return "rd";
      default:
        return "th";
    }
  },
  /**
   * Formats date object
   * @param {Date}
   * @param {String}
   * @param {Object}
   * @return {String}
   */
  formatDate(t, e, s) {
    s = s || v;
    let i = this.getFullYear(t), a = this.getMonth(t) + 1, l = this.getDate(t);
    return e.replace(/dd/, ("0" + l).slice(-2)).replace(/d/, l).replace(/yyyy/, i).replace(/yy/, String(i).slice(2)).replace(
      /MMMM/,
      this.getMonthName(this.getMonth(t), s.months)
    ).replace(
      /MMM/,
      this.getMonthNameAbbr(this.getMonth(t), s.monthsAbbr)
    ).replace(/MM/, ("0" + a).slice(-2)).replace(/M(?!a|ä|e)/, a).replace(/su/, this.getNthSuffix(this.getDate(t))).replace(/D(?!e|é|i)/, this.getDayNameAbbr(t, s.days));
  },
  /**
   * Creates an array of dates for each day in between two dates.
   * @param {Date} start
   * @param {Date} end
   * @return {Array}
   */
  createDateArray(t, e) {
    let s = [];
    for (; t <= e; )
      s.push(new Date(t)), t = this.setDate(new Date(t), this.getDate(new Date(t)) + 1);
    return s;
  },
  /**
   * method used as a prop validator for input values
   * @param {*} val
   * @return {Boolean}
   */
  validateDateInput(t) {
    return t === null || t instanceof Date || typeof t == "string" || typeof t == "number";
  }
}, u = (t) => ({ ...C, useUtc: t }), g = {
  ...C
};
var T = function() {
  var t = this, e = t.$createElement, s = t._self._c || e;
  return s("div", {
    class: {
      "input-group": t.bootstrapStyling
    }
  }, [t.calendarButton ? s("button", {
    staticClass: "vdp-datepicker__calendar-button",
    class: (t.bootstrapStyling, {
      disabled: t.disabled
    }),
    attrs: {
      type: "button"
    },
    on: {
      click: t.showCalendar
    }
  }, [t._t("calendarButton", function() {
    return [s("span", {
      class: {
        "input-group-text": t.bootstrapStyling
      }
    }, [s("i", {
      class: t.calendarButtonIcon
    }, [t._v(" " + t._s(t.calendarButtonIconContent) + " "), t.calendarButtonIcon ? t._e() : s("span", [t._v("…")])])])];
  })], 2) : t._e(), s("input", {
    ref: t.refName,
    class: t.computedInputClass,
    attrs: {
      id: t.id,
      type: t.inline ? "hidden" : "text",
      name: t.name,
      "open-date": t.openDate,
      placeholder: t.placeholder,
      "clear-button": t.clearButton,
      disabled: t.disabled,
      required: t.required,
      readonly: !t.typeable,
      autocomplete: "off"
    },
    domProps: {
      value: t.formattedValue
    },
    on: {
      click: t.showCalendar,
      keyup: t.parseTypedDate,
      blur: t.inputBlurred
    }
  }), t.clearButton && t.selectedDate ? s("button", {
    staticClass: "vdp-datepicker__clear-button",
    class: {
      "input-group-append": t.bootstrapStyling
    },
    attrs: {
      type: "button"
    },
    on: {
      click: function(i) {
        return t.clearDate();
      }
    }
  }, [t._t("clearButton", function() {
    return [s("span", {
      class: {
        "input-group-text": t.bootstrapStyling
      }
    }, [s("i", {
      class: t.clearButtonIcon
    }, [t.clearButtonIcon ? t._e() : s("span", [t._v("×")])])])];
  })], 2) : t._e(), t._t("afterDateInput")], 2);
}, $ = [];
function h(t, e, s, i, a, l, d, M) {
  var n = typeof t == "function" ? t.options : t;
  e && (n.render = e, n.staticRenderFns = s, n._compiled = !0), i && (n.functional = !0), l && (n._scopeId = "data-v-" + l);
  var o;
  if (d ? (o = function(r) {
    r = r || // cached call
    this.$vnode && this.$vnode.ssrContext || // stateful
    this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext, !r && typeof __VUE_SSR_CONTEXT__ < "u" && (r = __VUE_SSR_CONTEXT__), a && a.call(this, r), r && r._registeredComponents && r._registeredComponents.add(d);
  }, n._ssrRegister = o) : a && (o = M ? function() {
    a.call(
      this,
      (n.functional ? this.parent : this).$root.$options.shadowRoot
    );
  } : a), o)
    if (n.functional) {
      n._injectStyles = o;
      var Y = n.render;
      n.render = function(S, p) {
        return o.call(p), Y(S, p);
      };
    } else {
      var c = n.beforeCreate;
      n.beforeCreate = c ? [].concat(c, o) : [o];
    }
  return {
    exports: t,
    options: n
  };
}
const B = {
  props: {
    selectedDate: Date,
    resetTypedDate: [Date],
    format: [String, Function],
    translation: Object,
    inline: Boolean,
    id: String,
    name: String,
    refName: String,
    openDate: Date,
    placeholder: String,
    inputClass: [String, Object, Array],
    clearButton: Boolean,
    clearButtonIcon: String,
    calendarButton: Boolean,
    calendarButtonIcon: String,
    calendarButtonIconContent: String,
    disabled: Boolean,
    required: Boolean,
    typeable: Boolean,
    bootstrapStyling: Boolean,
    useUtc: Boolean
  },
  data() {
    return {
      input: null,
      typedDate: !1,
      utils: u(this.useUtc)
    };
  },
  computed: {
    formattedValue() {
      return this.selectedDate ? this.typedDate ? this.typedDate : typeof this.format == "function" ? this.format(this.selectedDate) : this.utils.formatDate(
        new Date(this.selectedDate),
        this.format + "",
        this.translation
      ) : null;
    },
    computedInputClass() {
      return this.bootstrapStyling ? typeof this.inputClass == "string" ? [this.inputClass, "form-control"].join(" ") : { "form-control": !0, ...this.inputClass } : this.inputClass;
    }
  },
  watch: {
    resetTypedDate() {
      this.typedDate = !1;
    }
  },
  mounted() {
    this.input = this.$el.querySelector("input");
  },
  methods: {
    showCalendar() {
      this.$emit("showCalendar");
    },
    /**
     * Attempt to parse a typed date
     * @param {Event} event
     */
    parseTypedDate(t) {
      if ([
        27,
        // escape
        13
        // enter
      ].includes(t.keyCode) && this.input.blur(), this.typeable) {
        const e = Date.parse(this.input.value);
        isNaN(e) || (this.typedDate = this.input.value, this.$emit("typedDate", new Date(this.typedDate)));
      }
    },
    /**
     * nullify the typed date to defer to regular formatting
     * called once the input is blurred
     */
    inputBlurred() {
      this.typeable && isNaN(Date.parse(this.input.value)) && (this.clearDate(), this.input.value = null, this.typedDate = null), this.$emit("closeCalendar");
    },
    /**
     * emit a clearDate event
     */
    clearDate() {
      this.$emit("clearDate");
    }
  }
}, D = {};
var V = /* @__PURE__ */ h(
  B,
  T,
  $,
  !1,
  x,
  null,
  null,
  null
);
function x(t) {
  for (let e in D)
    this[e] = D[e];
}
const N = /* @__PURE__ */ function() {
  return V.exports;
}();
var k = function() {
  var t = this, e = t.$createElement, s = t._self._c || e;
  return s("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: t.showDayView,
      expression: "showDayView"
    }],
    staticClass: "vdp-datepicker__calendar vdp-datepicker__calendar--day",
    class: [t.calendarClass, {
      "min-height": t.ensureMinHeight
    }],
    style: t.calendarStyle,
    on: {
      mousedown: function(i) {
        i.preventDefault();
      }
    }
  }, [t._t("beforeCalendarHeader"), s("header", {
    staticClass: "vdp-datepicker__header"
  }, [s("button", {
    staticClass: "prev",
    class: {
      disabled: t.isLeftNavDisabled
    },
    attrs: {
      type: "button",
      "aria-label": t.isRtl ? "<" : ">"
    },
    on: {
      click: function(i) {
        t.isRtl ? t.nextMonth() : t.previousMonth();
      }
    }
  }, [t._t(t.isRtl ? "nextButton" : "prevButton")], 2), t.allowedToShowView("month") ? s("button", {
    staticClass: "day__month_btn",
    class: t.allowedToShowView("month") ? "up" : "",
    attrs: {
      type: "button"
    },
    on: {
      click: t.showMonthCalendar
    }
  }, [t._v(" " + t._s(t.isYmd ? t.currYearName : t.currMonthName) + " " + t._s(t.isYmd ? t.currMonthName : t.currYearName) + " ")]) : s("span", {
    staticClass: "day__month_text"
  }, [t._v(" " + t._s(t.isYmd ? t.currYearName : t.currMonthName) + " " + t._s(t.isYmd ? t.currMonthName : t.currYearName) + " ")]), s("button", {
    staticClass: "next",
    class: {
      disabled: t.isRightNavDisabled
    },
    attrs: {
      type: "button",
      "aria-label": t.isRtl ? ">" : "<"
    },
    on: {
      click: function(i) {
        t.isRtl ? t.previousMonth() : t.nextMonth();
      }
    }
  }, [t._t(t.isRtl ? "prevButton" : "nextButton")], 2)]), s("div", {
    staticClass: "vdp-datepicker__pick-buttons vdp-datepicker__pick-buttons--day",
    class: t.isRtl ? "flex-rtl" : ""
  }, [t._l(t.daysOfWeekDataSource, function(i, a) {
    return s("span", {
      key: i.timestamp,
      staticClass: "cell day-header"
    }, [s("span", [t._v(t._s(t.format(i, a)))])]);
  }), t.blankDays > 0 ? t._l(t.blankDays, function(i) {
    return s("span", {
      key: i.timestamp,
      staticClass: "cell day blank"
    }, [s("span")]);
  }) : t._e(), t._l(t.days, function(i) {
    return s("button", {
      key: i.timestamp,
      staticClass: "cell day",
      class: t.dayClasses(i),
      attrs: {
        type: "button"
      },
      on: {
        click: function(a) {
          return t.selectDate(i);
        }
      }
    }, [s("span", {
      domProps: {
        innerHTML: t._s(t.dayCellContent(i))
      }
    })]);
  })], 2)], 2);
}, U = [];
const R = {
  components: {},
  props: {
    labelFormatter: Function,
    showDayView: Boolean,
    selectedDate: Date,
    pageDate: Date,
    pageTimestamp: Number,
    fullMonthName: Boolean,
    allowedToShowView: Function,
    dayCellContent: {
      type: Function,
      default: (t) => t.date
    },
    disabledDates: Object,
    highlighted: Object,
    calendarClass: [String, Object, Array],
    calendarStyle: Object,
    ensureMinHeight: Boolean,
    translation: Object,
    isRtl: Boolean,
    mondayFirst: Boolean,
    useUtc: Boolean,
    daysCustomDisplay: Array
  },
  data() {
    return {
      utils: u(this.useUtc)
    };
  },
  computed: {
    /**
     * Returns an array of day names
     * @return {String[]}
     */
    daysOfWeek() {
      if (this.mondayFirst) {
        const t = this.translation.days.slice();
        return t.push(t.shift()), t;
      }
      return this.translation.days;
    },
    daysOfWeekDataSource() {
      var t;
      return ((t = this.daysCustomDisplay) == null ? void 0 : t.length) === 7 ? this.daysCustomDisplay : this.daysOfWeek;
    },
    /**
     * Returns the day number of the week less one for the first of the current month
     * Used to show amount of empty cells before the first in the day calendar layout
     * @return {Number}
     */
    blankDays() {
      const t = this.pageDate;
      let e = this.useUtc ? new Date(Date.UTC(t.getUTCFullYear(), t.getUTCMonth(), 1)) : new Date(
        t.getFullYear(),
        t.getMonth(),
        1,
        t.getHours(),
        t.getMinutes()
      );
      return this.mondayFirst ? this.utils.getDay(e) > 0 ? this.utils.getDay(e) - 1 : 6 : this.utils.getDay(e);
    },
    /**
     * @return {Object[]}
     */
    days() {
      const t = this.pageDate;
      let e = [], s = this.useUtc ? new Date(Date.UTC(t.getUTCFullYear(), t.getUTCMonth(), 1)) : new Date(
        t.getFullYear(),
        t.getMonth(),
        1,
        t.getHours(),
        t.getMinutes()
      ), i = this.utils.daysInMonth(
        this.utils.getFullYear(s),
        this.utils.getMonth(s)
      );
      for (let a = 0; a < i; a++)
        e.push({
          date: this.utils.getDate(s),
          timestamp: s.getTime(),
          isSelected: this.isSelectedDate(s),
          isDisabled: this.isDisabledDate(s),
          isHighlighted: this.isHighlightedDate(s),
          isHighlightStart: this.isHighlightStart(s),
          isHighlightEnd: this.isHighlightEnd(s),
          isToday: this.utils.compareDates(s, /* @__PURE__ */ new Date()),
          isWeekend: this.utils.getDay(s) === 0 || this.utils.getDay(s) === 6,
          isSaturday: this.utils.getDay(s) === 6,
          isSunday: this.utils.getDay(s) === 0
        }), this.utils.setDate(s, this.utils.getDate(s) + 1);
      return e;
    },
    /**
     * Gets the name of the month the current page is on
     * @return {String}
     */
    currMonthName() {
      const t = this.fullMonthName ? this.translation.months : this.translation.monthsAbbr;
      return this.utils.getMonthNameAbbr(
        this.utils.getMonth(this.pageDate),
        t
      );
    },
    /**
     * Gets the name of the year that current page is on
     * @return {Number}
     */
    currYearName() {
      const t = this.translation.yearSuffix;
      return `${this.utils.getFullYear(this.pageDate)}${t}`;
    },
    /**
     * Is this translation using year/month/day format?
     * @return {Boolean}
     */
    isYmd() {
      return this.translation.ymd && this.translation.ymd === !0;
    },
    /**
     * Is the left hand navigation button disabled?
     * @return {Boolean}
     */
    isLeftNavDisabled() {
      return this.isRtl ? this.isNextMonthDisabled(this.pageTimestamp) : this.isPreviousMonthDisabled(this.pageTimestamp);
    },
    /**
     * Is the right hand navigation button disabled?
     * @return {Boolean}
     */
    isRightNavDisabled() {
      return this.isRtl ? this.isPreviousMonthDisabled(this.pageTimestamp) : this.isNextMonthDisabled(this.pageTimestamp);
    }
  },
  methods: {
    format(t, e) {
      return this.labelFormatter ? this.labelFormatter(t, e) : t;
    },
    selectDate(t) {
      if (t.isDisabled)
        return this.$emit("selectedDisabled", t), !1;
      this.$emit("selectDate", t);
    },
    /**
     * @return {Number}
     */
    getPageMonth() {
      return this.utils.getMonth(this.pageDate);
    },
    /**
     * Emit an event to show the month picker
     */
    showMonthCalendar() {
      this.$emit("showMonthCalendar");
    },
    /**
     * Change the page month
     * @param {Number} incrementBy
     */
    changeMonth(t) {
      let e = this.pageDate;
      this.utils.setMonth(e, this.utils.getMonth(e) + t), this.$emit("changedMonth", e);
    },
    /**
     * Decrement the page month
     */
    previousMonth() {
      this.isPreviousMonthDisabled() || this.changeMonth(-1);
    },
    /**
     * Is the previous month disabled?
     * @return {Boolean}
     */
    isPreviousMonthDisabled() {
      if (!this.disabledDates || !this.disabledDates.to)
        return !1;
      let t = this.pageDate;
      return this.utils.getMonth(this.disabledDates.to) >= this.utils.getMonth(t) && this.utils.getFullYear(this.disabledDates.to) >= this.utils.getFullYear(t);
    },
    /**
     * Increment the current page month
     */
    nextMonth() {
      this.isNextMonthDisabled() || this.changeMonth(1);
    },
    /**
     * Is the next month disabled?
     * @return {Boolean}
     */
    isNextMonthDisabled() {
      if (!this.disabledDates || !this.disabledDates.from)
        return !1;
      let t = this.pageDate;
      return this.utils.getMonth(this.disabledDates.from) <= this.utils.getMonth(t) && this.utils.getFullYear(this.disabledDates.from) <= this.utils.getFullYear(t);
    },
    /**
     * Whether a day is selected
     * @param {Date}
     * @return {Boolean}
     */
    isSelectedDate(t) {
      return this.selectedDate && this.utils.compareDates(this.selectedDate, t);
    },
    /**
     * Whether a day is disabled
     * @param {Date}
     * @return {Boolean}
     */
    isDisabledDate(t) {
      let e = !1;
      return typeof this.disabledDates > "u" ? !1 : (typeof this.disabledDates.dates < "u" && this.disabledDates.dates.forEach((s) => {
        if (this.utils.compareDates(t, s))
          return e = !0, !0;
      }), typeof this.disabledDates.to < "u" && this.disabledDates.to && t < this.disabledDates.to && (e = !0), typeof this.disabledDates.from < "u" && this.disabledDates.from && t > this.disabledDates.from && (e = !0), typeof this.disabledDates.ranges < "u" && this.disabledDates.ranges.forEach((s) => {
        if (typeof s.from < "u" && s.from && typeof s.to < "u" && s.to && t < s.to && t > s.from)
          return e = !0, !0;
      }), typeof this.disabledDates.days < "u" && this.disabledDates.days.indexOf(this.utils.getDay(t)) !== -1 && (e = !0), typeof this.disabledDates.daysOfMonth < "u" && this.disabledDates.daysOfMonth.indexOf(this.utils.getDate(t)) !== -1 && (e = !0), typeof this.disabledDates.customPredictor == "function" && this.disabledDates.customPredictor(t) && (e = !0), e);
    },
    /**
     * Whether a day is highlighted (only if it is not disabled already except when highlighted.includeDisabled is true)
     * @param {Date}
     * @return {Boolean}
     */
    isHighlightedDate(t) {
      if (!(this.highlighted && this.highlighted.includeDisabled) && this.isDisabledDate(t))
        return !1;
      let e = !1;
      return typeof this.highlighted > "u" ? !1 : (typeof this.highlighted.dates < "u" && this.highlighted.dates.forEach((s) => {
        if (this.utils.compareDates(t, s))
          return e = !0, !0;
      }), this.isDefined(this.highlighted.from) && this.isDefined(this.highlighted.to) && (e = t >= this.highlighted.from && t <= this.highlighted.to), typeof this.highlighted.days < "u" && this.highlighted.days.indexOf(this.utils.getDay(t)) !== -1 && (e = !0), typeof this.highlighted.daysOfMonth < "u" && this.highlighted.daysOfMonth.indexOf(this.utils.getDate(t)) !== -1 && (e = !0), typeof this.highlighted.customPredictor == "function" && this.highlighted.customPredictor(t) && (e = !0), e);
    },
    dayClasses(t) {
      return {
        selected: t.isSelected,
        disabled: t.isDisabled,
        highlighted: t.isHighlighted,
        today: t.isToday,
        weekend: t.isWeekend,
        sat: t.isSaturday,
        sun: t.isSunday,
        "highlight-start": t.isHighlightStart,
        "highlight-end": t.isHighlightEnd
      };
    },
    /**
     * Whether a day is highlighted and it is the first date
     * in the highlighted range of dates
     * @param {Date}
     * @return {Boolean}
     */
    isHighlightStart(t) {
      return this.isHighlightedDate(t) && this.highlighted.from instanceof Date && this.utils.getFullYear(this.highlighted.from) === this.utils.getFullYear(t) && this.utils.getMonth(this.highlighted.from) === this.utils.getMonth(t) && this.utils.getDate(this.highlighted.from) === this.utils.getDate(t);
    },
    /**
     * Whether a day is highlighted and it is the first date
     * in the highlighted range of dates
     * @param {Date}
     * @return {Boolean}
     */
    isHighlightEnd(t) {
      return this.isHighlightedDate(t) && this.highlighted.to instanceof Date && this.utils.getFullYear(this.highlighted.to) === this.utils.getFullYear(t) && this.utils.getMonth(this.highlighted.to) === this.utils.getMonth(t) && this.utils.getDate(this.highlighted.to) === this.utils.getDate(t);
    },
    /**
     * Helper
     * @param  {mixed}  prop
     * @return {Boolean}
     */
    isDefined(t) {
      return typeof t < "u" && t;
    }
  }
}, f = {};
var I = /* @__PURE__ */ h(
  R,
  k,
  U,
  !1,
  P,
  null,
  null,
  null
);
function P(t) {
  for (let e in f)
    this[e] = f[e];
}
const O = /* @__PURE__ */ function() {
  return I.exports;
}();
var H = function() {
  var t = this, e = t.$createElement, s = t._self._c || e;
  return s("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: t.showMonthView,
      expression: "showMonthView"
    }],
    staticClass: "vdp-datepicker__calendar vdp-datepicker__calendar--month",
    class: [t.calendarClass],
    style: t.calendarStyle,
    on: {
      mousedown: function(i) {
        i.preventDefault();
      }
    }
  }, [t._t("beforeCalendarHeader"), s("header", {
    staticClass: "vdp-datepicker__header"
  }, [s("button", {
    staticClass: "prev",
    class: {
      disabled: t.isLeftNavDisabled
    },
    attrs: {
      type: "button",
      "aria-label": t.isRtl ? "<" : ">"
    },
    on: {
      click: function(i) {
        t.isRtl ? t.nextYear() : t.previousYear();
      }
    }
  }, [t._t(t.isRtl ? "nextButton" : "prevButton")], 2), t.allowedToShowView("year") ? s("button", {
    staticClass: "month__year_btn",
    class: t.allowedToShowView("year") ? "up" : "",
    attrs: {
      type: "button"
    },
    on: {
      click: t.showYearCalendar
    }
  }, [s("span", [t._v(t._s(t.pageYearName))])]) : s("span", {
    staticClass: "month__year_text"
  }, [s("span", [t._v(t._s(t.pageYearName))])]), s("button", {
    staticClass: "next",
    class: {
      disabled: t.isRightNavDisabled
    },
    attrs: {
      type: "button",
      "aria-label": t.isRtl ? ">" : "<"
    },
    on: {
      click: function(i) {
        t.isRtl ? t.previousYear() : t.nextYear();
      }
    }
  }, [t._t(t.isRtl ? "prevButton" : "nextButton")], 2)]), s("div", {
    staticClass: "vdp-datepicker__pick-buttons vdp-datepicker__pick-buttons--month"
  }, t._l(t.months, function(i, a) {
    return s("button", {
      key: i.timestamp,
      staticClass: "cell month",
      class: {
        selected: i.isSelected,
        disabled: i.isDisabled
      },
      attrs: {
        type: "button"
      },
      on: {
        click: function(l) {
          return l.stopPropagation(), t.selectMonth(i);
        }
      }
    }, [t._v(" " + t._s(t.format(i.month, a)) + " ")]);
  }), 0)], 2);
}, j = [];
const E = {
  props: {
    labelFormatter: Function,
    showMonthView: Boolean,
    selectedDate: Date,
    pageDate: Date,
    pageTimestamp: Number,
    disabledDates: Object,
    calendarClass: [String, Object, Array],
    calendarStyle: Object,
    translation: Object,
    isRtl: Boolean,
    allowedToShowView: Function,
    useUtc: Boolean,
    monthsCustomDisplay: Array
  },
  data() {
    return {
      utils: u(this.useUtc)
    };
  },
  computed: {
    months() {
      var a;
      const t = this.pageDate;
      let e = [], s = this.useUtc ? new Date(Date.UTC(t.getUTCFullYear(), 0, t.getUTCDate())) : new Date(
        t.getFullYear(),
        0,
        t.getDate(),
        t.getHours(),
        t.getMinutes()
      ), i = ((a = this.monthsCustomDisplay) == null ? void 0 : a.length) === 12 ? this.monthsCustomDisplay : this.translation.months;
      for (let l = 0; l <= 11; l++)
        e.push({
          month: this.utils.getMonthName(l, i),
          timestamp: s.getTime(),
          isSelected: this.isSelectedMonth(s),
          isDisabled: this.isDisabledMonth(s)
        }), this.utils.setMonth(s, this.utils.getMonth(s) + 1);
      return e;
    },
    /**
     * Get year name on current page.
     * @return {String}
     */
    pageYearName() {
      const t = this.translation.yearSuffix;
      return `${this.utils.getFullYear(this.pageDate)}${t}`;
    },
    /**
     * Is the left hand navigation disabled
     * @return {Boolean}
     */
    isLeftNavDisabled() {
      return this.isRtl ? this.isNextYearDisabled(this.pageTimestamp) : this.isPreviousYearDisabled(this.pageTimestamp);
    },
    /**
     * Is the right hand navigation disabled
     * @return {Boolean}
     */
    isRightNavDisabled() {
      return this.isRtl ? this.isPreviousYearDisabled(this.pageTimestamp) : this.isNextYearDisabled(this.pageTimestamp);
    }
  },
  methods: {
    format(t, e) {
      return this.labelFormatter ? this.labelFormatter(t, e) : t;
    },
    /**
     * Emits a selectMonth event
     * @param {Object} month
     */
    selectMonth(t) {
      if (t.isDisabled)
        return !1;
      this.$emit("selectMonth", t);
    },
    /**
     * Changes the year up or down
     * @param {Number} incrementBy
     */
    changeYear(t) {
      let e = this.pageDate;
      this.utils.setFullYear(e, this.utils.getFullYear(e) + t), this.$emit("changedYear", e);
    },
    /**
     * Decrements the year
     */
    previousYear() {
      this.isPreviousYearDisabled() || this.changeYear(-1);
    },
    /**
     * Checks if the previous year is disabled or not
     * @return {Boolean}
     */
    isPreviousYearDisabled() {
      return !this.disabledDates || !this.disabledDates.to ? !1 : this.utils.getFullYear(this.disabledDates.to) >= this.utils.getFullYear(this.pageDate);
    },
    /**
     * Increments the year
     */
    nextYear() {
      this.isNextYearDisabled() || this.changeYear(1);
    },
    /**
     * Checks if the next year is disabled or not
     * @return {Boolean}
     */
    isNextYearDisabled() {
      return !this.disabledDates || !this.disabledDates.from ? !1 : this.utils.getFullYear(this.disabledDates.from) <= this.utils.getFullYear(this.pageDate);
    },
    /**
     * Emits an event that shows the year calendar
     */
    showYearCalendar() {
      this.$emit("showYearCalendar");
    },
    /**
     * Whether the selected date is in this month
     * @param {Date}
     * @return {Boolean}
     */
    isSelectedMonth(t) {
      return this.selectedDate && this.utils.getFullYear(this.selectedDate) === this.utils.getFullYear(t) && this.utils.getMonth(this.selectedDate) === this.utils.getMonth(t);
    },
    /**
     * Whether a month is disabled
     * @param {Date}
     * @return {Boolean}
     */
    isDisabledMonth(t) {
      let e = !1;
      return typeof this.disabledDates > "u" ? !1 : (typeof this.disabledDates.to < "u" && this.disabledDates.to && (this.utils.getMonth(t) < this.utils.getMonth(this.disabledDates.to) && this.utils.getFullYear(t) <= this.utils.getFullYear(this.disabledDates.to) || this.utils.getFullYear(t) < this.utils.getFullYear(this.disabledDates.to)) && (e = !0), typeof this.disabledDates.from < "u" && this.disabledDates.from && (this.utils.getMonth(t) > this.utils.getMonth(this.disabledDates.from) && this.utils.getFullYear(t) >= this.utils.getFullYear(this.disabledDates.from) || this.utils.getFullYear(t) > this.utils.getFullYear(this.disabledDates.from)) && (e = !0), typeof this.disabledDates.customPredictor == "function" && this.disabledDates.customPredictor(t) && (e = !0), e);
    }
  }
}, m = {};
var A = /* @__PURE__ */ h(
  E,
  H,
  j,
  !1,
  L,
  null,
  null,
  null
);
function L(t) {
  for (let e in m)
    this[e] = m[e];
}
const W = /* @__PURE__ */ function() {
  return A.exports;
}();
var q = function() {
  var t = this, e = t.$createElement, s = t._self._c || e;
  return s("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: t.showYearView,
      expression: "showYearView"
    }],
    staticClass: "vdp-datepicker__calendar vdp-datepicker__calendar--year",
    class: [t.calendarClass],
    style: t.calendarStyle,
    on: {
      mousedown: function(i) {
        i.preventDefault();
      }
    }
  }, [t._t("beforeCalendarHeader"), s("header", {
    staticClass: "vdp-datepicker__header"
  }, [s("button", {
    staticClass: "prev",
    class: {
      disabled: t.isLeftNavDisabled
    },
    attrs: {
      type: "button",
      "aria-label": "<"
    },
    on: {
      click: function(i) {
        t.isRtl ? t.nextDecade() : t.previousDecade();
      }
    }
  }, [t._t("prevButton")], 2), s("p", [t._v(t._s(t.getPageDecade))]), s("button", {
    staticClass: "next",
    class: {
      disabled: t.isRightNavDisabled
    },
    attrs: {
      type: "button",
      "aria-label": ">"
    },
    on: {
      click: function(i) {
        t.isRtl ? t.previousDecade() : t.nextDecade();
      }
    }
  }, [t._t("nextButton")], 2)]), s("div", {
    staticClass: "vdp-datepicker__pick-buttons vdp-datepicker__pick-buttons--year"
  }, t._l(t.years, function(i) {
    return s("button", {
      key: i.timestamp,
      staticClass: "cell year",
      class: {
        selected: i.isSelected,
        disabled: i.isDisabled
      },
      attrs: {
        type: "button"
      },
      on: {
        click: function(a) {
          return a.stopPropagation(), t.selectYear(i);
        }
      }
    }, [s("span", [t._v(t._s(t.format(i.year)))])]);
  }), 0)], 2);
}, J = [];
const X = {
  props: {
    formatter: Function,
    showYearView: Boolean,
    selectedDate: Date,
    pageDate: Date,
    pageTimestamp: Number,
    disabledDates: Object,
    highlighted: Object,
    calendarClass: [String, Object, Array],
    calendarStyle: Object,
    translation: Object,
    isRtl: Boolean,
    allowedToShowView: Function,
    useUtc: Boolean
  },
  data() {
    return {
      utils: u(this.useUtc)
    };
  },
  computed: {
    years() {
      const t = this.pageDate;
      let e = [], s = this.useUtc ? new Date(
        Date.UTC(
          Math.floor(t.getUTCFullYear() / 10) * 10,
          t.getUTCMonth(),
          t.getUTCDate()
        )
      ) : new Date(
        Math.floor(t.getFullYear() / 10) * 10,
        t.getMonth(),
        t.getDate(),
        t.getHours(),
        t.getMinutes()
      );
      for (let i = 0; i < 10; i++)
        e.push({
          year: this.utils.getFullYear(s),
          timestamp: s.getTime(),
          isSelected: this.isSelectedYear(s),
          isDisabled: this.isDisabledYear(s)
        }), this.utils.setFullYear(s, this.utils.getFullYear(s) + 1);
      return e;
    },
    /**
     * @return {String}
     */
    getPageDecade() {
      const t = Math.floor(this.utils.getFullYear(this.pageDate) / 10) * 10, e = t + 9, s = this.translation.yearSuffix;
      return `${t} - ${e}${s}`;
    },
    /**
     * Is the left hand navigation button disabled?
     * @return {Boolean}
     */
    isLeftNavDisabled() {
      return this.isRtl ? this.isNextDecadeDisabled(this.pageTimestamp) : this.isPreviousDecadeDisabled(this.pageTimestamp);
    },
    /**
     * Is the right hand navigation button disabled?
     * @return {Boolean}
     */
    isRightNavDisabled() {
      return this.isRtl ? this.isPreviousDecadeDisabled(this.pageTimestamp) : this.isNextDecadeDisabled(this.pageTimestamp);
    }
  },
  methods: {
    format(t) {
      return this.formatter ? this.formatter(t) : t;
    },
    selectYear(t) {
      if (t.isDisabled)
        return !1;
      this.$emit("selectYear", t);
    },
    changeYear(t) {
      let e = this.pageDate;
      this.utils.setFullYear(e, this.utils.getFullYear(e) + t), this.$emit("changedDecade", e);
    },
    previousDecade() {
      if (this.isPreviousDecadeDisabled())
        return !1;
      this.changeYear(-10);
    },
    isPreviousDecadeDisabled() {
      if (!this.disabledDates || !this.disabledDates.to)
        return !1;
      const t = this.utils.getFullYear(this.disabledDates.to), e = Math.floor(this.utils.getFullYear(this.pageDate) / 10) * 10 - 1;
      return t > e;
    },
    nextDecade() {
      if (this.isNextDecadeDisabled())
        return !1;
      this.changeYear(10);
    },
    isNextDecadeDisabled() {
      if (!this.disabledDates || !this.disabledDates.from)
        return !1;
      const t = this.utils.getFullYear(this.disabledDates.from), e = Math.ceil(this.utils.getFullYear(this.pageDate) / 10) * 10;
      return t < e;
    },
    /**
     * Whether the selected date is in this year
     * @param {Date}
     * @return {Boolean}
     */
    isSelectedYear(t) {
      return this.selectedDate && this.utils.getFullYear(this.selectedDate) === this.utils.getFullYear(t);
    },
    /**
     * Whether a year is disabled
     * @param {Date}
     * @return {Boolean}
     */
    isDisabledYear(t) {
      let e = !1;
      return typeof this.disabledDates > "u" || !this.disabledDates ? !1 : (typeof this.disabledDates.to < "u" && this.disabledDates.to && this.utils.getFullYear(t) < this.utils.getFullYear(this.disabledDates.to) && (e = !0), typeof this.disabledDates.from < "u" && this.disabledDates.from && this.utils.getFullYear(t) > this.utils.getFullYear(this.disabledDates.from) && (e = !0), typeof this.disabledDates.customPredictor == "function" && this.disabledDates.customPredictor(t) && (e = !0), e);
    }
  }
}, b = {};
var Z = /* @__PURE__ */ h(
  X,
  q,
  J,
  !1,
  z,
  null,
  null,
  null
);
function z(t) {
  for (let e in b)
    this[e] = b[e];
}
const G = /* @__PURE__ */ function() {
  return Z.exports;
}();
var K = function() {
  var t = this, e = t.$createElement, s = t._self._c || e;
  return s("svg", {
    attrs: {
      width: "14",
      height: "14",
      viewBox: "0 0 14 14",
      fill: "none"
    }
  }, [s("path", {
    attrs: {
      "fill-rule": "evenodd",
      "clip-rule": "evenodd",
      d: "M9.0016 0.71811C9.37534 0.32692 10 0.32692 10.3737 0.71811C10.7241 1.08485 10.7241 1.6623 10.3737 2.02904L5.62456 7L10.3737 11.971C10.7241 12.3377 10.7241 12.9152 10.3737 13.2819C10 13.6731 9.37534 13.6731 9.0016 13.2819L2.99997 7L9.0016 0.71811Z",
      fill: "currentColor"
    }
  })]);
}, Q = [];
const tt = {}, y = {};
var et = /* @__PURE__ */ h(
  tt,
  K,
  Q,
  !1,
  st,
  null,
  null,
  null
);
function st(t) {
  for (let e in y)
    this[e] = y[e];
}
const it = /* @__PURE__ */ function() {
  return et.exports;
}();
var at = function() {
  var t = this, e = t.$createElement, s = t._self._c || e;
  return s("svg", {
    attrs: {
      width: "14",
      height: "14",
      viewBox: "0 0 14 14",
      fill: "none"
    }
  }, [s("path", {
    attrs: {
      "fill-rule": "evenodd",
      "clip-rule": "evenodd",
      d: "M4.9984 0.71811C4.62466 0.32692 3.99999 0.32692 3.62625 0.71811C3.27587 1.08485 3.27587 1.6623 3.62625 2.02904L8.37544 7L3.62625 11.971C3.27587 12.3377 3.27587 12.9152 3.62625 13.2819C3.99999 13.6731 4.62466 13.6731 4.9984 13.2819L11 7L4.9984 0.71811Z",
      fill: "currentColor"
    }
  })]);
}, nt = [];
const lt = {}, _ = {};
var rt = /* @__PURE__ */ h(
  lt,
  at,
  nt,
  !1,
  ot,
  null,
  null,
  null
);
function ot(t) {
  for (let e in _)
    this[e] = _[e];
}
const ht = /* @__PURE__ */ function() {
  return rt.exports;
}();
var ut = function() {
  var t = this, e = t.$createElement, s = t._self._c || e;
  return s("div", {
    staticClass: "vdp-datepicker",
    class: [t.wrapperClass, t.isRtl ? "rtl" : ""]
  }, [s("DateInput", {
    attrs: {
      id: t.id,
      selectedDate: t.selectedDate,
      resetTypedDate: t.resetTypedDate,
      format: t.format,
      translation: t.translation,
      inline: t.inline,
      name: t.name,
      refName: t.refName,
      openDate: t.openDate,
      placeholder: t.placeholder,
      inputClass: t.inputClass,
      typeable: t.typeable,
      clearButton: t.clearButton,
      clearButtonIcon: t.clearButtonIcon,
      calendarButton: t.calendarButton,
      calendarButtonIcon: t.calendarButtonIcon,
      calendarButtonIconContent: t.calendarButtonIconContent,
      disabled: t.disabled,
      required: t.required,
      bootstrapStyling: t.bootstrapStyling,
      useUtc: t.useUtc
    },
    on: {
      showCalendar: t.showCalendar,
      closeCalendar: t.close,
      typedDate: t.setTypedDate,
      clearDate: t.clearDate
    }
  }, [t._t("afterDateInput", null, {
    slot: "afterDateInput"
  }), t._t("clearButton", null, {
    slot: "clearButton"
  })], 2), s("div", {
    staticClass: "vdp-datepicker__body"
  }, [t.allowedToShowView("day") ? s("PickerDay", {
    attrs: {
      labelFormatter: t.dayFormatter,
      pageDate: t.pageDate,
      selectedDate: t.selectedDate,
      showDayView: t.showDayView,
      fullMonthName: t.fullMonthName,
      allowedToShowView: t.allowedToShowView,
      disabledDates: t.disabledDates,
      highlighted: t.highlighted,
      calendarClass: t.calendarClass,
      calendarStyle: t.calendarStyle,
      ensureMinHeight: t.ensureMinHeight,
      translation: t.translation,
      pageTimestamp: t.pageTimestamp,
      isRtl: t.isRtl,
      mondayFirst: t.mondayFirst,
      dayCellContent: t.dayCellContent,
      useUtc: t.useUtc,
      daysCustomDisplay: t.daysCustomDisplay
    },
    on: {
      changedMonth: t.handleChangedMonthFromDayPicker,
      selectDate: t.selectDate,
      showMonthCalendar: t.showMonthCalendar,
      selectedDisabled: t.selectDisabledDate
    }
  }, [t._t("beforeCalendarHeader", null, {
    slot: "beforeCalendarHeader"
  }), t._t("prevButton", function() {
    return [s("IconLeft")];
  }, {
    slot: "prevButton"
  }), t._t("nextButton", function() {
    return [s("IconRight")];
  }, {
    slot: "nextButton"
  })], 2) : t._e(), t.allowedToShowView("month") ? s("PickerMonth", {
    attrs: {
      labelFormatter: t.monthFormatter,
      pageDate: t.pageDate,
      selectedDate: t.selectedDate,
      showMonthView: t.showMonthView,
      allowedToShowView: t.allowedToShowView,
      disabledDates: t.disabledDates,
      calendarClass: t.calendarClass,
      calendarStyle: t.calendarStyle,
      translation: t.translation,
      isRtl: t.isRtl,
      useUtc: t.useUtc,
      monthsCustomDisplay: t.monthsCustomDisplay
    },
    on: {
      selectMonth: t.selectMonth,
      showYearCalendar: t.showYearCalendar,
      changedYear: t.setPageDate
    }
  }, [t._t("beforeCalendarHeader", null, {
    slot: "beforeCalendarHeader"
  }), t._t("prevButton", function() {
    return [s("IconLeft")];
  }, {
    slot: "prevButton"
  }), t._t("nextButton", function() {
    return [s("IconRight")];
  }, {
    slot: "nextButton"
  })], 2) : t._e(), t.allowedToShowView("year") ? s("PickerYear", {
    attrs: {
      formatter: t.yearFormatter,
      pageDate: t.pageDate,
      selectedDate: t.selectedDate,
      showYearView: t.showYearView,
      allowedToShowView: t.allowedToShowView,
      disabledDates: t.disabledDates,
      calendarClass: t.calendarClass,
      calendarStyle: t.calendarStyle,
      translation: t.translation,
      isRtl: t.isRtl,
      useUtc: t.useUtc
    },
    on: {
      selectYear: t.selectYear,
      changedDecade: t.setPageDate
    }
  }, [t._t("beforeCalendarHeader", null, {
    slot: "beforeCalendarHeader"
  }), t._t("prevButton", function() {
    return [s("IconLeft")];
  }, {
    slot: "prevButton"
  }), t._t("nextButton", function() {
    return [s("IconRight")];
  }, {
    slot: "nextButton"
  })], 2) : t._e()], 1)], 1);
}, dt = [];
const ct = {
  components: {
    DateInput: N,
    PickerDay: O,
    PickerMonth: W,
    PickerYear: G,
    IconLeft: it,
    IconRight: ht
  },
  props: {
    value: {
      validator: (t) => g.validateDateInput(t)
    },
    name: String,
    refName: String,
    id: String,
    format: {
      type: [String, Function],
      default: "dd MMM yyyy"
    },
    language: {
      type: Object,
      default: () => v
    },
    openDate: {
      validator: (t) => g.validateDateInput(t)
    },
    dayCellContent: Function,
    dayFormatter: Function,
    monthFormatter: Function,
    yearFormatter: Function,
    fullMonthName: Boolean,
    disabledDates: Object,
    highlighted: Object,
    placeholder: String,
    inline: Boolean,
    ensureMinHeight: Boolean,
    calendarClass: [String, Object, Array],
    inputClass: [String, Object, Array],
    wrapperClass: [String, Object, Array],
    mondayFirst: Boolean,
    clearButton: Boolean,
    clearButtonIcon: String,
    calendarButton: Boolean,
    calendarButtonIcon: String,
    calendarButtonIconContent: String,
    bootstrapStyling: Boolean,
    initialView: String,
    disabled: Boolean,
    required: Boolean,
    typeable: Boolean,
    useUtc: Boolean,
    useRtl: {
      type: Boolean,
      default: null
    },
    minimumView: {
      type: String,
      default: "day"
    },
    maximumView: {
      type: String,
      default: "year"
    },
    daysCustomDisplay: Array,
    monthsCustomDisplay: Array
  },
  data() {
    const t = this.openDate ? new Date(this.openDate) : /* @__PURE__ */ new Date(), e = u(this.useUtc);
    return {
      /*
       * Vue cannot observe changes to a Date Object so date must be stored as a timestamp
       * This represents the first day of the current viewing month
       * {Number}
       */
      pageTimestamp: e.setDate(t, 1),
      /*
       * Selected Date
       * {Date}
       */
      selectedDate: null,
      /*
       * Flags to show calendar views
       * {Boolean}
       */
      showDayView: !1,
      showMonthView: !1,
      showYearView: !1,
      /*
       * Positioning
       */
      calendarHeight: 0,
      resetTypedDate: /* @__PURE__ */ new Date(),
      utils: e
    };
  },
  computed: {
    computedInitialView() {
      return this.initialView ? this.initialView : this.minimumView;
    },
    pageDate() {
      return new Date(this.pageTimestamp);
    },
    translation() {
      return this.language;
    },
    calendarStyle() {
      return {
        position: this.isInline ? "relative" : void 0
      };
    },
    isOpen() {
      return this.showDayView || this.showMonthView || this.showYearView;
    },
    isInline() {
      return !!this.inline;
    },
    isRtl() {
      return this.useRtl != null ? this.useRtl : this.translation.rtl === !0;
    }
  },
  watch: {
    value(t) {
      this.setValue(t);
    },
    openDate() {
      this.setPageDate();
    },
    initialView() {
      this.setInitialView();
    }
  },
  mounted() {
    this.init();
  },
  methods: {
    /**
     * Called in the event that the user navigates to date pages and
     * closes the picker without selecting a date.
     */
    resetDefaultPageDate() {
      if (this.selectedDate === null) {
        this.setPageDate();
        return;
      }
      this.setPageDate(this.selectedDate);
    },
    /**
     * Effectively a toggle to show/hide the calendar
     * @return {mixed}
     */
    showCalendar() {
      if (this.disabled || this.isInline)
        return !1;
      if (this.isOpen)
        return this.close(!0);
      this.setInitialView();
    },
    /**
     * Sets the initial picker page view: day, month or year
     */
    setInitialView() {
      const t = this.computedInitialView;
      if (!this.allowedToShowView(t))
        throw new Error(
          `initialView '${this.initialView}' cannot be rendered based on minimum '${this.minimumView}' and maximum '${this.maximumView}'`
        );
      switch (t) {
        case "year":
          this.showYearCalendar();
          break;
        case "month":
          this.showMonthCalendar();
          break;
        default:
          this.showDayCalendar();
          break;
      }
    },
    /**
     * Are we allowed to show a specific picker view?
     * @param {String} view
     * @return {Boolean}
     */
    allowedToShowView(t) {
      const e = ["day", "month", "year"], s = e.indexOf(this.minimumView), i = e.indexOf(this.maximumView), a = e.indexOf(t);
      return a >= s && a <= i;
    },
    /**
     * Show the day picker
     * @return {Boolean}
     */
    showDayCalendar() {
      return this.allowedToShowView("day") ? (this.close(), this.showDayView = !0, !0) : !1;
    },
    /**
     * Show the month picker
     * @return {Boolean}
     */
    showMonthCalendar() {
      return this.allowedToShowView("month") ? (this.close(), this.showMonthView = !0, !0) : !1;
    },
    /**
     * Show the year picker
     * @return {Boolean}
     */
    showYearCalendar() {
      return this.allowedToShowView("year") ? (this.close(), this.showYearView = !0, !0) : !1;
    },
    /**
     * Set the selected date
     * @param {Number} timestamp
     */
    setDate(t) {
      const e = new Date(t);
      this.selectedDate = e, this.setPageDate(e), this.$emit("selected", e), this.$emit("input", e);
    },
    /**
     * Clear the selected date
     */
    clearDate() {
      this.selectedDate = null, this.setPageDate(), this.$emit("selected", null), this.$emit("input", null), this.$emit("cleared");
    },
    /**
     * @param {Object} date
     */
    selectDate(t) {
      this.setDate(t.timestamp), this.isInline || this.close(!0), this.resetTypedDate = /* @__PURE__ */ new Date();
    },
    /**
     * @param {Object} date
     */
    selectDisabledDate(t) {
      this.$emit("selectedDisabled", t);
    },
    /**
     * @param {Object} month
     */
    selectMonth(t) {
      const e = new Date(t.timestamp);
      this.allowedToShowView("day") ? (this.setPageDate(e), this.$emit("changedMonth", t), this.showDayCalendar()) : this.selectDate(t);
    },
    /**
     * @param {Object} year
     */
    selectYear(t) {
      const e = new Date(t.timestamp);
      this.allowedToShowView("month") ? (this.setPageDate(e), this.$emit("changedYear", t), this.showMonthCalendar()) : this.selectDate(t);
    },
    /**
     * Set the datepicker value
     * @param {Date|String|Number|null} date
     */
    setValue(t) {
      if (typeof t == "string" || typeof t == "number") {
        let e = new Date(t);
        t = isNaN(e.valueOf()) ? null : e;
      }
      if (!t) {
        this.setPageDate(), this.selectedDate = null;
        return;
      }
      this.selectedDate = t, this.setPageDate(t);
    },
    /**
     * Sets the date that the calendar should open on
     */
    setPageDate(t) {
      t || (this.openDate ? t = new Date(this.openDate) : t = /* @__PURE__ */ new Date()), this.pageTimestamp = this.utils.setDate(new Date(t), 1);
    },
    /**
     * Handles a month change from the day picker
     */
    handleChangedMonthFromDayPicker(t) {
      this.setPageDate(t), this.$emit("changedMonth", t);
    },
    /**
     * Set the date from a typedDate event
     */
    setTypedDate(t) {
      this.setDate(t.getTime());
    },
    /**
     * Close all calendar layers
     * @param {Boolean} emitEvent - emit close event
     */
    close(t) {
      this.showDayView = this.showMonthView = this.showYearView = !1, this.isInline || (t && this.$emit("closed"), document.removeEventListener("click", this.clickOutside, !1));
    },
    /**
     * Initiate the component
     */
    init() {
      this.value && this.setValue(this.value), this.isInline && this.setInitialView();
    }
  }
}, w = {};
var pt = /* @__PURE__ */ h(
  ct,
  ut,
  dt,
  !1,
  gt,
  null,
  null,
  null
);
function gt(t) {
  for (let e in w)
    this[e] = w[e];
}
const Dt = /* @__PURE__ */ function() {
  return pt.exports;
}();
export {
  Dt as DatePicker,
  F as Language
};
